/*************************************************************************
 *                                                                       *
 *                               MEMFILE.H                               *
 *                                                                       *
 *************************************************************************

                          Copyright 1996 Echidna

   DESCRIPTION


   PROGRAMMERS


   FUNCTIONS

   TABS : 5 9

   HISTORY
		03/28/96 : Created.

	The Echidna Copyright
	
	Copyright 1991-2003 Echidna, Inc. All rights reserved.
	
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are
	met:
	
	* Redistributions of source code must retain the above copyright notice,
	  this list of conditions and the following disclaimer.
	
	* Redistributions in binary form must reproduce the above copyright
	  notice, this list of conditions and the following disclaimer in the
	  documentation and/or other materials provided with the distribution.
	
	THIS SOFTWARE IS PROVIDED BY Echidna ``AS IS'' AND ANY EXPRESS OR IMPLIED
	WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
	NO EVENT SHALL Echidna OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
	NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	
	The views and conclusions contained in the software and documentation are
	those of the authors and should not be interpreted as representing
	official policies, either expressed or implied, of Echidna or
	Echidna, Inc.

 *************************************************************************/

#ifndef EL_MEMFILE_H
#define EL_MEMFILE_H
/**************************** I N C L U D E S ****************************/

#include <stdio.h>

/*************************** C O N S T A N T S ***************************/


/******************************* T Y P E S *******************************/

typedef unsigned char uint8;

typedef struct MEMFILE
{
	uint8	*buffer;
	uint8	*curPtr;
	long	 size;
	long	 bytesLeft;
}
MEMFILE;

/***************************** G L O B A L S *****************************/


/****************************** M A C R O S ******************************/


#define	MEMFILE_getc(mf) \
	(((mf)->bytesLeft > 0) ? (((mf)->bytesLeft--),(*mf->curPtr++)) : EOF)

/************************** P R O T O T Y P E S **************************/

extern MEMFILE *MEMFILE_Load (const char* filename);
extern void MEMFILE_Close (MEMFILE *mf);
extern int MEMFILE_Read(MEMFILE *mf, void *buf, long len);
extern int MEMFILE_Seek (MEMFILE *mf, long pos, int type);

#endif  /* EL_MEMFILE_H */
